'Goniometer detector with LDR or BPW34
'
'measures LED brightness vs angle
'servo turns LED 0 to 180 degrees
'
'ADC channel 3: +5V -LDR- PB3 -10k- -GND
'
'***************************************************************************
'
'  Pinout ATtiny13/ATtiny13V   8-PDIP/SOIC
'
' (PCINT5/RESET/ADC0/dW)   PB5 VCC
' (PCINT3/CLKI/ADC3)       PB3 PB2 (SCK/ADC1/T0/PCINT2)
' (PCINT4/ADC2)            PB4 PB1 (MISO/AIN1/OC0B/INT0/PCINT1)
'                          GND PB0 (MOSI/AIN0/OC0A/PCINT0)
'
'***************************************************************************
' PB0 input   Pushbutton
' PB1 output  blink
' PB2 output  Servo
' PB4 output  COM1
' PB3 input   ADC channel 3, connect LDR or BPW34
'***************************************************************************

$regfile = "attiny13.dat"
$crystal = 9600000
$hwstack = 8
$swstack = 8
$framesize = 4

Const Svmin = 60
Const Svmax = 140
Const Svnull = 100
Const Channel = 3                                           'ADC

Pushbutton Alias Pinb.0

Dim I As Byte , J As Byte
Dim Svpos As Byte
Dim W As Word , Avglight As Word

Portb = &B00000001
Ddrb = &B00010110

$asm                                                        'turn on 9.6 MHz CLK
  ldi  R24, &B10000000                                      'prescale en
  Out Clkpr , R24
  ldi  R24, &B00000000                                      'prescale 1
  Out Clkpr , R24
$end Asm


Config Adc = Single , Prescaler = Auto , Reference = Avcc
Didr0.adc3d = 1
Start Adc

Config Servos = 1 , Servo1 = Portb.2 , Reload = 10

'Acsr.acd = 0                                                ' switch off analog comparator

Open "comb.4:9600,8,n,1,INVERTED" For Output As #1
Enable Interrupts

For I = Svmin To Svmax                                      'test servo
  Servo(1) = I
  Waitms 30
Next

Do                                                          'main loop

Servo(1) = Svnull                                           ' go to mid pos


Goagain:                                                    ' time to adjust
 Avglight = Getadc(channel)
 Toggle Portb.1
 Disable Interrupts
 Print #1 , "555," ; Avglight                               'send data
 Enable Interrupts
 Waitms 100
If Pushbutton = 1 Then                                      'push to continue
 Goto Goagain
End If                                                      'check pin

Servo(1) = Svmin                                            ' go to start pos
Waitms 10

For I = Svmin To Svmax                                      'test
  Servo(1) = I
  Waitms 100
  Avglight = 0
  For J = 1 To 4
     W = Getadc(channel)
     Avglight = Avglight + W
  Next J
  Shift Avglight , Right , 2

  Disable Interrupts
  Print #1 , I ; "," ; Avglight                             'send data
  Enable Interrupts
Next I

Waitmore:                                                   'done, now wait
If Pushbutton = 1 Then                                      'for pushbutton
 Goto Waitmore
End If                                                      'check pin
Waithigh:                                                   'done, now wait
If Pushbutton = 0 Then                                      'for pushbutton
 Goto Waithigh
End If                                                      'check pin


Loop                                                        'main loop again

End